#!/usr/bin/perl -- # -*- perl -*-

# The bitmaps for each of the Chinese digits.
@0 = ("0xf8,0x0f",
"0x80,0x00",
"0xfe,0x7f",
"0x82,0x40",
"0xb9,0x2e",
"0x80,0x00",
"0xb8,0x0e",
"0x40,0x01",
"0x30,0x06",
"0x4c,0x18",
"0x83,0x60",
"0xf0,0x07",
"0x00,0x02",
"0x40,0x01",
"0x80,0x00",
"0x00,0x01");

@1 = ("0x00,0x00",
"0x00,0x00",
"0x00,0x00",
"0x00,0x00",
"0x00,0x00",
"0x00,0x00",
"0x00,0x20",
"0xff,0x7f",
"0x00,0x00",
"0x00,0x00",
"0x00,0x00",
"0x00,0x00",
"0x00,0x00",
"0x00,0x00",
"0x00,0x00",
"0x00,0x00");

@2 = ("0x00,0x00",
"0x00,0x00",
"0x00,0x08",
"0xfc,0x1f",
"0x00,0x00",
"0x00,0x00",
"0x00,0x00",
"0x00,0x00",
"0x00,0x00",
"0x00,0x00",
"0x00,0x00",
"0x00,0x20",
"0xff,0x7f",
"0x00,0x00",
"0x00,0x00",
"0x00,0x00");

@3 = ("0x00,0x00",
"0x00,0x10",
"0xfe,0x3f",
"0x00,0x00",
"0x00,0x00",
"0x00,0x00",
"0x00,0x08",
"0xfc,0x1f",
"0x00,0x00",
"0x00,0x00",
"0x00,0x00",
"0x00,0x00",
"0x00,0x20",
"0xff,0x7f",
"0x00,0x00",
"0x00,0x00");

@4 = ("0x00,0x00",
"0x00,0x20",
"0xfe,0x7f",
"0x22,0x22",
"0x22,0x22",
"0x22,0x22",
"0x22,0x22",
"0x22,0x22",
"0x22,0x22",
"0x22,0x3c",
"0x12,0x20",
"0x0a,0x20",
"0x02,0x20",
"0xfe,0x3f",
"0x02,0x20",
"0x00,0x00");

@5 = ("0x00,0x00",
"0x00,0x10",
"0xfe,0x3f",
"0x40,0x00",
"0x40,0x00",
"0x40,0x00",
"0x40,0x08",
"0xfc,0x3f",
"0x20,0x08",
"0x20,0x08",
"0x20,0x08",
"0x10,0x08",
"0x10,0x08",
"0x10,0x28",
"0xff,0x7f",
"0x00,0x00");

@6 = ("0x00,0x00",
"0x20,0x00",
"0x40,0x00",
"0xc0,0x00",
"0x80,0x20",
"0xff,0x7f",
"0x00,0x00",
"0x00,0x00",
"0x20,0x02",
"0x30,0x04",
"0x10,0x08",
"0x08,0x18",
"0x08,0x30",
"0x04,0x30",
"0x02,0x20",
"0x00,0x00");

@7 = ("0x40,0x00",
"0x40,0x00",
"0x40,0x00",
"0x40,0x00",
"0x40,0x00",
"0x40,0x20",
"0xc0,0x7f",
"0x7f,0x00",
"0x40,0x00",
"0x40,0x00",
"0x40,0x00",
"0x40,0x20",
"0x40,0x20",
"0x40,0x20",
"0x80,0x3f",
"0x00,0x00");

@8 = ("0x00,0x00",
"0x00,0x02",
"0x20,0x02",
"0x20,0x02",
"0x20,0x02",
"0x20,0x02",
"0x20,0x02",
"0x20,0x02",
"0x10,0x04",
"0x10,0x04",
"0x10,0x04",
"0x08,0x08",
"0x08,0x10",
"0x04,0x70",
"0x02,0x20",
"0x00,0x00");

@9 = ("0x20,0x00",
"0x20,0x00",
"0x20,0x00",
"0x20,0x04",
"0xff,0x0f",
"0x20,0x04",
"0x20,0x04",
"0x20,0x04",
"0x20,0x04",
"0x20,0x04",
"0x10,0x04",
"0x10,0x04",
"0x08,0x44",
"0x08,0x44",
"0x04,0x78",
"0x03,0x00");

# Remove trailing slash
$ENV{'PATH_INFO'} =~ s/^\/?(.+)$/\1/;

# Create a file to hold the count if it doesn't exist already
# otherwise update the count.  Can change  bbn.com and erols.com
# be the domains names of where you access your account from so
# that you don't update the counter when you visit it.
# This program will try to create the count files in a "counts"
# subdirectory from the cgi directory.  You must create it beforehand
# and give it wide enough permissions to allow the files to be created
# in it.

unless (-e "counts/$ENV{'PATH_INFO'}.count") {
    open(COUNT, "> counts/$ENV{'PATH_INFO'}.count");
    print COUNT "x";
    $count = 1;
} else {
    unless ($ENV{'REMOTE_HOST'} =~ m/^bbn.com$/ ||
	    $ENV{'REMOTE_HOST'} =~ m/erols.com$/) {
	open(COUNT, ">> counts/$ENV{'PATH_INFO'}.count");
	print COUNT "x";
	close(COUNT);
    }
    $count = -s "counts/$ENV{'PATH_INFO'}.count";
}

$count = sprintf("%010d", $count);
# Strip off trailing zero's
$count =~ s/^0*([0-9]+)$/\1/;

$countlen = length($count);

# If counter does not work, uncomment the print statements to
# get a view of what the server environment is and what is actually
# getting printed out.

#print "Content-type: text/plain\n\n";
#print `env` , "\n";

print "Content-type: image/x-xbitmap\n\n";
print "#define ccount_width " , 16 * $countlen , "\n";
print "#define ccount_height 16\n";
print "static char count_bits[] = {\n";

# Print out the array of bytes
for ($j = 0; $j < 16; $j++) {
    for ($i = 0; $i < $countlen; $i++) {
	print ${substr($count, $i, 1)}[$j] , ",";
    }
    print "\n";
}

print "};\n";
